﻿/**
 * Explosion
 * Author: codelite
 * Description: explosion effect
 */
package  codelite
{
	/** flash classes **/
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.media.Sound;
	
	public class Explosion extends Sprite
	{		
		private var _particles	:Array		=	[];		// holder for particles reference
		private var _parent		:NewGame	=	null;	// new game class reference
		private var _sound 		:Sound   	= 	null;	// sound object
		
		/** constructor
			@param: $i - new game class reference
		**/
		public function Explosion($i:NewGame)
		{
			// new explosion sound
			_sound = new ExplosionSound();
            _sound.play();
			
			// set reference
			_parent = $i;
			
			var angleDifference:Number = 360 / 8;
			var angle:Number = 0;			
			
			// generate  particles
			for (var i:int = 0; i<8; i++) 
			{
				_particles.push( new Particle() );
				_particles[_particles.length-1]._speedY = Math.sin(angle * Math.PI/180)*3;
				_particles[_particles.length-1]._speedX = Math.cos(angle * Math.PI/180)*3;
				addChild(_particles[_particles.length-1]);
				angle += angleDifference;
			}
			
			this.addEventListener(Event.ENTER_FRAME,Update,false,0,true);
		}
		
		/** update the explosion **/
		private function Update(e:Event):void
		{
			for each (var a:Particle in _particles)
			{
				a.y += a._speedY;
				a.x += a._speedX;

				a.alpha -= 0.05;
				
				if (a.alpha < -0.1) 
				{
					_parent.RemoveExplosion(this);
					return;
				}
			}
		}
		
		/** clear **/
		public function Clear():void
		{
			this.removeEventListener (Event.ENTER_FRAME, Update);
			for (var i:int = 0; i<8; i++) 
			{
				removeChild(_particles[i]);
				_particles[i].Destructor();
				_particles[i]=null;
			}
			
			_sound = null;
			
			_particles=[];
			_particles=null;
			
			_parent=null;
		}
		
	}
}