﻿/**
 * HowToPlay
 * Author: codelite
 * Description: how to play the game
 */
package codelite
{
	/** flash classes **/
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	/** custom classes **/
	import codelite.utils.Public;
	import codelite.utils.TextLabel;
	import codelite.utils.CustomGlow;
	
	public class HowToPlayTheGame extends Sprite
	{
		private var _title  :TextLabel 	= null;	// title text label
		private var _text   :TextLabel 	= null;	// text  label
		private var _close  :TextLabel 	= null;	// close button
		private var _display:Display 	= null;	// display reference
		
		/** constructor 
			@param: $display - display reference
		**/
		public function HowToPlayTheGame($display:Display)
		{
			_display = $display;
			
			// new title instance
			_title = new TextLabel();
			_title.SetFormat(70,0xFF6B00,  true, "center");
			_title.SetText("How To Play");
			_title.x = Public.ReturnStage().stageWidth/2 - _title.width/2;
			_title.y = 50;
			CustomGlow.Glow(_title,0x000000);
			addChild(_title);
			
			// new text instance
			_text = new TextLabel();
			_text.SetFormat(27,0xF68B1F,  false, "justify", true, true, 450, 5);
			_text.SetText("You are in control of a nano ship trying to defend the cells being destroyed by viruses.<br>The aim of the game is to survive as long as you can.<br><br>- left and right arrow moves the ship<br>- space key fires the projectiles");
			_text.x = Public.ReturnStage().stageWidth/2 - _text.width/2;
			_text.y = 130;
			CustomGlow.Glow(_text,0x000000);
			addChild(_text);
			
			// new close button
			_close = new TextLabel();
			_close.SetFormat(27,0xFF6B00,  false, "justify");
			_close.SetText("back to menu");
			_close.x = Public.ReturnStage().stageWidth/2 - _close.width/2;
			_close.y = 345;
			CustomGlow.Glow(_close,0x000000);
			_close.buttonMode = true;
			_close.addEventListener(MouseEvent.CLICK, _display.ReturnToMenu ,false, 0, true);
			addChild(_close);
		}
		
		/** clear this from memory **/
		public function Clear():void
		{
			removeChild(_title);
			_title.Clear();
			_title = null;
			
			removeChild(_text);
			_text.Clear();
			_text = null;
			
			removeChild(_close);
			_close.removeEventListener(MouseEvent.CLICK, _display.ReturnToMenu);
			_close.Clear();
			_close = null;
		}
	}
}