﻿/**
 * MainCell
 * Author: codelite
 * Description: main cell object
 */
package  codelite
{ 
	/** flash classes **/
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	
	/** custom classes **/
	import codelite.utils.Public;
	import codelite.utils.CustomGlow;
	
	public class MainCell extends MainCellGfx
	{
		private var _shield  	:Number	     =	5;	// shield
		private var _coordX		:Number      =	0;	// x position
		private var _coordY		:Number	     =	0;	// y position
		
		/** constructor **/
		public function MainCell()
		{
			this.filters=[new BlurFilter(2,2,2)]
			
			_coordX = Public.ReturnStage().stageWidth/2 
			_coordY = Public.ReturnStage().stageHeight/2

			this.x = _coordX;
			this.y = _coordY;

			this.addEventListener(Event.ENTER_FRAME,Shake,false,0,true);
		}

		/** shake effect **/
		private function Shake($e:Event):void
		{
			this.x = _coordX+ MinusOrPlus()*(Math.random()*1);
			this.y = _coordY+ MinusOrPlus()*(Math.random()*1);
		}
		
		/** used for the shake effect **/
		private function MinusOrPlus():int
		{
			var $rand : int = Math.round(Math.random()*(1-0)+0);
			var $val:int = 0;
			
			if ($rand == 1) $val =-1;
			else $val = 1;
			
			return $val;
		}
		
		/** returnd the value of the shield **/
		public function ReturnShield():int
		{
			return _shield;
		}
		
		/** the cell was hit - reduces shield **/
		public function ShieldHit():void
		{
			_shield -=1;
			if(_shield < 0 ) _shield = 0;
		}
		
		/** clear from memory  **/
		public function Clear():void
		{
			this.removeEventListener(Event.ENTER_FRAME,Shake);
			this.filters = null;
		}
	}
}