﻿/**
 * TextLabel
 * Author: codelite
 * Description: text label
 */
package codelite.utils
{
	/** import the necessary classes **/
	import flash.display.Sprite;
	import flash.text.TextFormat;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	
	public class TextLabel extends Sprite
	{							
		private var _textfield:TextField = new TextField(); // text field instance
		
		/** constructor **/
		public function TextLabel()
		{
			// remove any mouse events effects
			this.mouseChildren 		= false;
			
			// remove any interactivity of the textfield 
			_textfield.selectable   = false;
			_textfield.mouseEnabled = false;
			
			//add the texfield to the display list
			addChild(_textfield);
		}
		
		/** set the textfield's text 
		 *  @text: $text - text
		 **/
		public function SetText($text:String):void
		{
			_textfield.htmlText = $text;
		}
		
		/** formats the textfield
		 *  @param: $font      - font name
		 *  @param: $size      - size of the font
		 *  @param: $color     - color of the font
		 *  @param: $bold      - if the font is bold
		 *  @param: $align     - text aligmnet
		 *  @param: $wordwrap  - if text is wraped
		 *  @param: $multiline - if textfield is multilined
		 *  @param: $w         - width of the text
		 *  @param: $h         - height of the text
		 **/
		
		public function SetFormat($size:Number, $color:Number, $bold:Boolean, $align:String, $wordwrap:Boolean=false,$multiline:Boolean=false, $w:Number =5, $h:Number =5 ):void
		{
			// setup the text field
			_textfield.multiline  = $multiline
			_textfield.wordWrap   = $wordwrap
			_textfield.width 	  = $w;
			_textfield.height	  = $h;
			_textfield.autoSize   = TextFieldAutoSize.LEFT;
			_textfield.embedFonts = true;
			
			// text field formatting
			var $format:TextFormat = new TextFormat();
			$format.font  = "Font";
			$format.size  = $size;
			$format.color = $color;
			$format.bold  = $bold;
			$format.align = $align;
			
			// apply the formatting to the text field
			_textfield.setTextFormat($format);
			_textfield.defaultTextFormat = $format ;

		}	
		
		/** resize the  textfield
		 *  @text: $width - new width
		 **/
		public function SetW($width:Number):void
		{
			_textfield.width = $width;
		}
		
		/** destroy the instance **/
		public function Clear():void
		{
			removeChild(_textfield)
			_textfield=null;
		}
	}
}